jQuery(document).ready(function($) {

	wpcc_url = $('.wpcc_url').val();
	
	/* JQ Field */	
	$.fn.wpcc_jq_field = function () {

		$(this).each(function() {
		
			var this_f 		= $(this);
			var this_input 	= $('.wpcc_jq_' + this_f.data('get_id'));
			
			if(this_input.data('type') == 'inputtext')
			{
				this_input.keyup( function()
				{
					this_f.val(this_input.val());
				});
			}
			else if(this_input.data('type') == 'select')
			{
				this_input.change( function()
				{
					this_f.val(this_input.val());
				});
			}
			else if(this_input.data('type') == 'radio')
			{
				this_input.each(function()
				{
					$(this).click( function()
					{
						this_f.val($(this).val());
					});
				});
			}
			else if(this_input.data('type') == 'checkbox')
			{
				this_input.each(function()
				{
					$(this).click( function()
					{
						if($(this).prop("checked"))
						{
							this_f.val($(this).val());
						}
						else
						{
							this_f.val('');
						}
					});
				});

			}
			else if(this_input.data('type') == 'slider')
			{
				this_input.mouseup( function()
				{
					this_f.val($('.wpcc_jq_slider_hidden', $(this).parent()).val());
				});
			}
		});
	};
	$('.wpcc_jq_copy').wpcc_jq_field();

	/* JQ IF */
	$.fn.wpcc_jq_if = function () {
		$(this).each(function() {
			var if_id 			= $(this).data('if_id');
			var if_operator 	= $(this).data('operator');
			var if_val 			= String($(this).data('val'));
			var if_show_id		= $(this).data('show');
			var if_hide_id		= $(this).data('hide');
			var if_field 		= $('.wpcc_jq_' + if_id);
			
			if(if_field.data('type') == 'inputtext')
			{
				$(if_field).live('keyup', function()
				{
					$(this).wpcc_jq_if_check_condition($(this).val(), if_val, if_operator, if_show_id, if_hide_id);
				});
			}
			else if(if_field.data('type') == 'select')
			{
				if_field.change( function()
				{
					$(this).wpcc_jq_if_check_condition($(this).val(), if_val, if_operator, if_show_id, if_hide_id);
				});
			}
			else if(if_field.data('type') == 'checkbox')
			{
				if_field.click( function()
				{
					$(this).wpcc_jq_if_check_condition($(this).val(), if_val, if_operator, if_show_id, if_hide_id);
				});
			}
			else if(if_field.data('type') == 'radio')
			{
				if_field.click( function()
				{
					$(this).wpcc_jq_if_check_condition($(this).val(), if_val, if_operator, if_show_id, if_hide_id);
				});
			}
			else if(if_field.data('type') == 'slider')
			{
				$('.wpcc_jq_slider_box', $(this).parent()).mousemove( function()
				{
					$(this).wpcc_jq_if_check_condition($(this).val(), if_val, if_operator, if_show_id, if_hide_id);
				});
			}
		});
	};
	$('.wpcc_jq_if').wpcc_jq_if();
	
	/* If Change */
	$.fn.wpcc_jq_if_change = function(ids, fn) {
		ids_string = String(ids);
		if(ids_string.length > 0) {
		
			var this_check_arr_show	= ids_string.indexOf(",");
			
			if(this_check_arr_show >= '0')
			{
				var this_show_arr 	= ids_string.split(",");
				for (i = 0; i < this_show_arr.length; i++ ) {
					if(fn == 'show')
					{
						$('.wpcc_jq_if_' + this_show_arr[i]).show();
					}
					else if(fn == 'hide')
					{
						$('.wpcc_jq_if_' + this_show_arr[i]).hide();
					}
				}
			}
			else
			{
				if(fn == 'show')
				{
					$('.wpcc_jq_if_' + ids_string).show();
				}
				else if(fn == 'hide')
				{
					$('.wpcc_jq_if_' + ids_string).hide();
				}
			}
		}
	};
	
	/* Сondition */
	$.fn.wpcc_jq_if_check_condition = function (value, if_val, operator, s, h) {
		var this_type = $(this).data('type');
		
		if(this_type == 'checkbox')
		{
			var for_checked = $(this).prop("checked");
		}
		else
		{
			var for_checked = true;
		}
		if(operator != '==')
		{
			var value 	= value - 0;
			var if_val 	= if_val - 0;
		}
		if(
			( operator == '==' && ( for_checked && value == if_val ) )
			||
			( operator == '>=' && ( for_checked && value >= if_val ) )
			||
			( operator == '<=' && ( for_checked && value <= if_val ) )
			||
			( operator == '>' && ( for_checked && value > if_val ) )
			||
			( operator == '<' && ( for_checked && value < if_val ) )
		)
		{
			$(this).wpcc_jq_if_change(s, 'show');
			$(this).wpcc_jq_if_change(h, 'hide');
		}
		else
		{
			$(this).wpcc_jq_if_change(s, 'hide');
			$(this).wpcc_jq_if_change(h, 'show');
		}
	}
	
	/* Slider */
	$.fn.wpcc_slider = function () {
		$(this).each(function() {
			var this_sl  = $(this);
			var sl_va = $(this).data('value');
			var sl_mi = $(this).data('min');
			var sl_ma = $(this).data('max');
			var sl_st = $(this).data('step');
			var sl_po = $(this).data('position');
			$('.wpcc_jq_slider_box', this_sl).slider({
				orientation: sl_po,
				range: 'min',
				value: sl_va,
				min: sl_mi,
				max: sl_ma,
				step: sl_st,
				slide: function( event, ui ) {
					$( '.wpcc_jq_slider_text', this_sl ).html( ui.value );
					$( '.wpcc_jq_slider_hidden', this_sl ).val( ui.value );
				}
			});
		});
	}
	$('.wpcc_jq_slider').wpcc_slider();
	
	/* WPCC Validation */
		/* Only Numbers */
		$.fn.wpcc_validation_only_number = function () {
			$(this).each(function() {
				$(this).live("keyup click", function() {
					if ( this.value.match( /[^0-9.]/g ) )
					{
						this.value = this.value.replace( ',', '.' );
						this.value = this.value.replace( /[^0-9.]/g, '' );
					}
				});
			});
		};
		$('.wpcc_jq_validation_only_numbers').wpcc_validation_only_number();
	
	/* Send Calc */
	$('.wpcc_form .wpcc_submit').live('click', function() {
		var wpcc_this_p = $(this).parent();
		var wpcc_id 	= $('.wpcc_id', wpcc_this_p).val();
		
		$('.wpcc_loading div', wpcc_this_p).show();
		$.post(
			wpcc_url + '/action/wpcc_result.php',
			wpcc_this_p.serialize(),
			function(data){
				$('.wpcc_result_block_' + wpcc_id).html(data);
				$('.wpcc_loading div', wpcc_this_p).hide();
				
				$('html,body').animate({
					scrollTop: $('.wpcc_result_block').offset().top
				}, 800);
			}
		);
		return false;
	});
	
	/* Send Mail */
	$('.wpcc_mail .wpcc_submit').live('click', function() {
		var wpcc_this_p = $(this).parent();
		var wpcc_id 	= $('.wpcc_id', wpcc_this_p).val();
		
		$('.wpcc_loading div', wpcc_this_p).show();
		$.post(
			wpcc_url + '/action/wpcc_mail.php',
			wpcc_this_p.serialize(),
			function(data){
				$('.wpcc_result_block_' + wpcc_id).html(data);
				$('.wpcc_loading div', wpcc_this_p).hide();
			}
		);
		return false;
	});
	
});