<?php
/*
Plugin Name: wp-creator-calculator
Plugin URI: http://zetrider.ru/wpcc/
Description: Creating forms calculator, the introduction of the template and write
Version: 3.5.5
Author: ZetRider
Author URI: http://zetrider.ru
Author Email: ZetRider@bk.ru
*/
/*  Copyright 2013  zetrider  (email: zetrider@bk.ru)

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/

define('WPCC_PLUGIN_NAME', dirname(plugin_basename(__FILE__)) );
define('WPCC_PLUGIN_DIR', WP_PLUGIN_DIR . '/' . WPCC_PLUGIN_NAME );
define('WPCC_PLUGIN_URL', WP_PLUGIN_URL  . '/' . WPCC_PLUGIN_NAME );

$wpcc_DB = $wpdb->prefix.'creator_calculator';

load_plugin_textdomain('wpcc', PLUGINDIR . '/' . WPCC_PLUGIN_NAME . '/lang/');

function wpcc_admin_menu(){
	$ico 	= WPCC_PLUGIN_URL . "/images/wpcc.png";
	$page 	= add_menu_page('WPCC', 'WPCC', 'manage_options', 'wpcc', 'wpcc_setting', "$ico");
	add_action('admin_print_scripts-' . $page, 'wpcc_admin_scripts');
	add_action('admin_print_styles-' . $page, 'wpcc_styles');
}
add_action('admin_menu', 'wpcc_admin_menu');

function wpcc_admin_scripts() {
	wp_enqueue_script('jquery-ui-core');
	wp_enqueue_script('jquery-ui-sortable');
	wp_enqueue_script('jquery-ui-slider');
	wp_register_script('wpcc-action', WPCC_PLUGIN_URL . '/js/action.js');
	wp_enqueue_script('wpcc-action');
}

function wpcc_styles() {  
	wp_enqueue_style('wpcc_style', WPCC_PLUGIN_URL . '/style.css');
}

function wpcc_init() {
	if (!session_id()) {
		session_start(); 
	}
	
	wp_enqueue_script('jquery');
}
add_action('init', 'wpcc_init');

function wpcc_load_script() {

	$wpcc_script_load_post 	= get_option('wpcc_script_load_post', 0);
	$wpcc_script_load_page 	= get_option('wpcc_script_load_page', 0);
	$arr_post = explode(',', $wpcc_script_load_post);
	$arr_page = explode(',', $wpcc_script_load_page);

	if(
		( (is_single() AND in_array(get_the_ID(), $arr_post)) OR (is_single() AND $wpcc_script_load_post == '0') )
		OR
		( (is_page() AND in_array(get_the_ID(), $arr_page)) OR (is_page() AND $wpcc_script_load_page == '0') )
		OR
		( $wpcc_script_load_post == '0' AND $wpcc_script_load_page == '0' )
	)
	{
		wp_enqueue_script('jquery-ui-core');
		wp_enqueue_script('jquery-ui-slider');
	}
		
}  
add_action('wp_enqueue_scripts', 'wpcc_load_script');  

function wpcc_esc_attr($text='') {
	return trim(stripslashes(esc_html($text)));
}

function wpcc_print_r($arr='') {
	echo '<pre>';
	print_r($arr);
	echo '</pre>';
}

function wpcc_price($price='') {
	$price = trim($price);
	$price = str_replace(',','.', $price);
	$price = preg_replace('/[^0-9.]/', '', $price);
	return $price;
}

$wpcc_type_field = array(
	'textblock' => array(
		'name' 	=> __('Text Block','wpcc'),
		'child' => array(
					'title',
					'text',
					'hidden_display'
					)
	),
	'select' => array(
		'name' 	=> 'SELECT',
		'child' => array(
					'title',
					'signto',
					'signaf',
					'list',
					'exclude',
					'hidden_display'
					)
	),
	'checkbox' => array(
		'name' 	=> 'Checkbox',
		'child' => array(
					'title',
					'signto',
					'signaf',
					'default',
					'list',
					'action',
					'exclude',
					'hidden_display'
					)
	),
	'radio' => array(
		'name' 	=> 'Radio',
		'child' => array(
					'title',
					'signto',
					'signaf',
					'list',
					'exclude',
					'hidden_display'
					)
	),
	'inputtext' => array(
		'name' 	=> 'Input Text',
		'child' => array(
					'title',
					'signto',
					'signaf',
					'default',
					'price',
					'action',
					'exclude',
					'hidden_display',
					'validation'
					)
	),
	'hidden' => array(
		'name' 	=> 'Input Hidden',
		'child' => array(
					'signto',
					'signaf',
					'price'
					)
	),
	'session' => array(
		'name' 	=> '$_SESSION',
		'child' => array(
					'signto',
					'signaf',
					'default',
					'sess_calc_id',
					'sess_calc_results'
					)
	),
	'jquery' => array(
		'name' 	=> __('jQuery field','wpcc'),
		'child' => array(
					'signto',
					'signaf',
					'default',
					'jq_id'
					)
	),
	'slider' => array(
		'name' 	=> 'Slider',
		'child' => array(
					'title',
					'signto',
					'signaf',
					'default',
					'exclude',
					'hidden_display',
					'slider_min',
					'slider_max',
					'slider_step',
					'slider_position'
					)
	),
	'if' => array(
		'name' 	=> __('Condition IF VAL FIELD == VAL USER','wpcc'),
		'child' => array(
					'if_id',
					'if_val',
					'if_show',
					'if_hide',
					'if_operator'
					)
	),
	'armtc' => array(
		'name' 	=> __('Arithmetic Function','wpcc'),
		'child' => array(
					'signto',
					'signaf',
					'armtc_fn'
					)
	),
	'result_fields' => array(
		'name' 	=> __('Result Fields','wpcc'),
		'child' => array(
					'signto',
					'signaf',
					'default',
					'action',
					'rf_fields'
					)
	)
);

$wpcc_name_field = array(
	'title' 				=> __('Title','wpcc'),
	'signto' 				=> __('Sign to','wpcc'),
	'signaf' 				=> __('Sign after','wpcc'),
	'default' 				=> __('Default','wpcc'),
	'price' 				=> __('Price','wpcc'),
	'action' 				=> __('Action','wpcc'),
	'text' 					=> __('Text','wpcc'),
	'list' 					=> __('List','wpcc'),
	'exclude' 				=> __('This field is involved in the calculation formula?','wpcc'),
	'validation' 			=> __('Validation','wpcc'),
	'hidden_display' 		=> __('Visually hide a field?','wpcc'),
	'sess_calc_id' 			=> __('ID calculator','wpcc'),
	'sess_calc_results' 	=> __('ID field or the sum','wpcc'),
	'jq_id' 				=> __('ID field','wpcc'),
	'if_id' 				=> __('What field compare','wpcc'),
	'if_val' 				=> __('The field value for the condition','wpcc'),
	'if_show' 				=> __('Which fields are displayed','wpcc'),
	'if_hide' 				=> __('What is hidden','wpcc'),
	'if_operator' 			=> __('IF Operator','wpcc'),
	'armtc_fn' 				=> __('What is the function use','wpcc'),
	'slider_min' 			=> __('The minimum value of','wpcc'),
	'slider_max' 			=> __('Maximum','wpcc'),
	'slider_step' 			=> __('Step','wpcc'),
	'slider_position' 		=> __('Position','wpcc'),
	'rf_fields'			=> __('ID list of fields separated by commas','wpcc')
);

function wpcc_cache_field($wpcc_query='', $field_id='') {
	foreach($wpcc_query as $wpcc_row)
	{
		if($wpcc_row->wpcc_field == $field_id)
		{
			$wpcc_value [$wpcc_row->wpcc_type] = $wpcc_row->wpcc_value;
		}
	}
	return $wpcc_value;
}
	
/* wpcc row add and edit */
function wpcc_row_field($type, $wpcc_query='', $field_id='') {
	global $wpdb, $wpcc_DB, $wpcc_type_field, $wpcc_name_field;
	
	$wpcc_id 	= intval($_GET['wpcc_id']);
	$wpcc_value = wpcc_cache_field($wpcc_query, $field_id);
	
	/* Option Hide Value */
	$select_exclude_arr = array(
		'1' 	=> __('Yes','wpcc'),
		'2' 	=> __('No','wpcc')
	);
	$select_exclude = '';
	foreach($select_exclude_arr as $select_exclude_k => $select_exclude_v)
	{
		$select_exclude .= '<option value="'.$select_exclude_k.'" '.(($select_exclude_k == $wpcc_value['exclude'])?'selected':'').'>'.$select_exclude_v.'</option>';
	}
	/* Option Hide Display Value */
	$select_hidden_display_arr = array(
		'0' 	=> __('No','wpcc'),
		'1' 	=> __('Yes, add display: none','wpcc')
	);
	$select_hidden_display = '';
	foreach($select_hidden_display_arr as $select_hidden_display_k => $select_hidden_display_v)
	{
		$select_hidden_display .= '<option value="'.$select_hidden_display_k.'" '.(($select_hidden_display_k == $wpcc_value['hidden_display'])?'selected':'').'>'.$select_hidden_display_v.'</option>';
	}
	/* Option Armtc Value */
	$select_armtc_arr = array(
		'bcsqrt' 	=> __('The square root of the number sqrt($number)','wpcc'),
		'bcpow' 	=> __('Modular power of pow ($number, $exp)','wpcc')
	);
	$select_armtc = '';
	foreach($select_armtc_arr as $select_armtc_k => $select_armtc_v)
	{
		$select_armtc .= '<option value="'.$select_armtc_k.'" '.(($select_armtc_k == $wpcc_value['armtc_fn'])?'selected':'').'>'.$select_armtc_v.'</option>';
	}
	/* Option Slider Value */
	$select_slider_arr = array(
		'vertical' 		=> __('Vertical','wpcc'),
		'horizontal'	=> __('Horizontal','wpcc')
	);
	$select_slider = '';
	foreach($select_slider_arr as $select_slider_k => $select_slider_v)
	{
		$select_slider .= '<option value="'.$select_slider_k.'" '.(($select_slider_k == $wpcc_value['slider_position'])?'selected':'').'>'.$select_slider_v.'</option>';
	}
	/* Option If Operator Value */
	$select_if_operator_arr = array(
		'=='	=> '==',
		'<'		=> '<',
		'<='	=> '<=',
		'>'		=> '>',
		'>='	=> '>='
	);
	$select_if_operator = '';
	foreach($select_if_operator_arr as $select_if_operator_k => $select_if_operator_v)
	{
		$select_if_operator .= '<option value="'.$select_if_operator_k.'" '.(($select_if_operator_k == $wpcc_value['if_operator'])?'selected':'').'>'.$select_if_operator_v.'</option>';
	}
	/* Option Validation */
	$select_validation_arr = array(
		''				=> '---',
		'only_numbers'	=> __('Only Numbers and dot','wpcc')
	);
	$select_validation = '';
	foreach($select_validation_arr as $select_validation_k => $select_validation_v)
	{
		$select_validation .= '<option value="'.$select_validation_k.'" '.(($select_validation_k == $wpcc_value['validation'])?'selected':'').'>'.$select_validation_v.'</option>';
	}
	
	$child['title'] 			= '<div class="name">'. $wpcc_name_field['title'] .': <sup><a title="help" href="http://zetrider.ru/wpcc-help.html?faq='.$type.'_title#'.$type.'_title" target="_blank">?</a></sup></div> <input type="text" name="wpcc_cild[title]" class="input" value="'.wpcc_esc_attr($wpcc_value['title']).'"><br><div class="clear"></div>';
	$child['signto'] 			= '<div class="name">'. $wpcc_name_field['signto'] .': <sup><a title="help" href="http://zetrider.ru/wpcc-help.html?faq='.$type.'_signto#'.$type.'_signto" target="_blank">?</a></sup></div> <input type="text" name="wpcc_cild[signto]" class="input" value="'.wpcc_esc_attr($wpcc_value['signto']).'"><br><div class="clear"></div>';
	$child['signaf'] 			= '<div class="name">'. $wpcc_name_field['signaf'] .': <sup><a title="help" href="http://zetrider.ru/wpcc-help.html?faq='.$type.'_signaf#'.$type.'_signaf" target="_blank">?</a></sup></div> <input type="text" name="wpcc_cild[signaf]" class="input" value="'.wpcc_esc_attr($wpcc_value['signaf']).'"><br><div class="clear"></div>';
	$child['default'] 			= '<div class="name">'. $wpcc_name_field['default'] .': <sup><a title="help" href="http://zetrider.ru/wpcc-help.html?faq='.$type.'_default#'.$type.'_default" target="_blank">?</a></sup></div> <input type="text" name="wpcc_cild[default]" class="input" value="'.wpcc_esc_attr($wpcc_value['default']).'"><br><div class="clear"></div>';
	$child['price'] 			= '<div class="name">'. $wpcc_name_field['price'] .': <sup><a title="help" href="http://zetrider.ru/wpcc-help.html?faq='.$type.'_price#'.$type.'_price" target="_blank">?</a></sup></div> <input type="text" name="wpcc_cild[price]" class="input" value="'.wpcc_esc_attr($wpcc_value['price']).'"><br><div class="clear"></div>';
	$child['action'] 			= '<div class="name">'. $wpcc_name_field['action'] .': <sup><a title="help" href="http://zetrider.ru/wpcc-help.html?faq='.$type.'_action#'.$type.'_action" target="_blank">?</a></sup></div> <input type="text" name="wpcc_cild[action]" class="input" value="'.wpcc_esc_attr($wpcc_value['action']).'"><br><div class="clear"></div>';
	$child['text'] 				= '<div class="name">'. $wpcc_name_field['text'] .': <sup><a title="help" href="http://zetrider.ru/wpcc-help.html?faq='.$type.'_text#'.$type.'_text" target="_blank">?</a></sup><br> <small>Можно вставить результат из SESSION:<br> [session id="ID_CALC"]'. __('ID_ROW or sum calc', 'wpcc') .'[/session]</small></div> <textarea name="wpcc_cild[text]" class="textarea">'.wpcc_esc_attr($wpcc_value['text']).'</textarea><br><div class="clear"></div>';
	$child['list'] 				= '<div class="name">'. $wpcc_name_field['list'] .': <sup><a title="help" href="http://zetrider.ru/wpcc-help.html?faq='.$type.'_list#'.$type.'_list" target="_blank">?</a></sup><br> <small>100:title<br>200:title</small></div> <textarea name="wpcc_cild[list]" class="textarea">'.wpcc_esc_attr($wpcc_value['list']).'</textarea><br><div class="clear"></div>';
	$child['exclude'] 			= '<div class="name">'. $wpcc_name_field['exclude'] .': <sup><a title="help" href="http://zetrider.ru/wpcc-help.html?faq='.$type.'_exclude#'.$type.'_exclude" target="_blank">?</a></sup></div> <select name="wpcc_cild[exclude]" class="select">'.$select_exclude.'</select><br><div class="clear"></div>';
	$child['hidden_display'] 	= '<div class="name">'. $wpcc_name_field['hidden_display'] .': <sup><a title="help" href="http://zetrider.ru/wpcc-help.html?faq='.$type.'_hidden_display#'.$type.'_hidden_display" target="_blank">?</a></sup></div> <select name="wpcc_cild[hidden_display]" class="select">'.$select_hidden_display.'</select><br><div class="clear"></div>';
	$child['validation'] 		= '<div class="name">'. $wpcc_name_field['validation'] .': <sup><a title="help" href="http://zetrider.ru/wpcc-help.html?faq='.$type.'_validation#'.$type.'_validation" target="_blank">?</a></sup></div> <select name="wpcc_cild[validation]" class="select">'.$select_validation.'</select><br><div class="clear"></div>';
	
	$child['sess_calc_id'] 		= '<div class="name">'. $wpcc_name_field['sess_calc_id'] .': <sup><a title="help" href="http://zetrider.ru/wpcc-help.html?faq='.$type.'_sess_calc_id#'.$type.'_sess_calc_id" target="_blank">?</a></sup></div> <input type="text" name="wpcc_cild[sess_calc_id]" class="input" value="'.wpcc_esc_attr($wpcc_value['sess_calc_id']).'"><br><div class="clear"></div>';
	$child['sess_calc_results'] = '<div class="name">'. $wpcc_name_field['sess_calc_results'] .': <sup><a title="help" href="http://zetrider.ru/wpcc-help.html?faq='.$type.'_sess_calc_results#'.$type.'_sess_calc_results" target="_blank">?</a></sup></div> <input type="text" name="wpcc_cild[sess_calc_results]" class="input" value="'.wpcc_esc_attr($wpcc_value['sess_calc_results']).'"><br><div class="clear"></div>';
	
	$child['jq_id'] 			= '<div class="name">'. $wpcc_name_field['jq_id'] .': <sup><a title="help" href="http://zetrider.ru/wpcc-help.html?faq='.$type.'_jq_id#'.$type.'_jq_id" target="_blank">?</a></sup></div> <input type="text" name="wpcc_cild[jq_id]" class="input" value="'.wpcc_esc_attr($wpcc_value['jq_id']).'"><br><div class="clear"></div>';
	
	$child['if_id'] 			= '<div class="name">'. $wpcc_name_field['if_id'] .'<br> '. __('ID field','wpcc') .': <sup><a title="help" href="http://zetrider.ru/wpcc-help.html?faq='.$type.'_if_id#'.$type.'_if_id" target="_blank">?</a></sup></div> <input type="text" name="wpcc_cild[if_id]" class="input" value="'.wpcc_esc_attr($wpcc_value['if_id']).'"><br><div class="clear"></div>';
	$child['if_val'] 			= '<div class="name">'. $wpcc_name_field['if_val'] .': <sup><a title="help" href="http://zetrider.ru/wpcc-help.html?faq='.$type.'_if_val#'.$type.'_if_val" target="_blank">?</a></sup></div> <input type="text" name="wpcc_cild[if_val]" class="input" value="'.wpcc_esc_attr($wpcc_value['if_val']).'"><br><div class="clear"></div>';
	$child['if_show'] 			= '<div class="name">'. $wpcc_name_field['if_show'] .'<br> '. __('ID fields separated by commas','wpcc') .': <sup><a title="help" href="http://zetrider.ru/wpcc-help.html?faq='.$type.'_if_show#'.$type.'_if_show" target="_blank">?</a></sup></div> <input type="text" name="wpcc_cild[if_show]" class="input" value="'.wpcc_esc_attr($wpcc_value['if_show']).'" placeholder="1,2,3,4"><br><div class="clear"></div>';
	$child['if_hide'] 			= '<div class="name">'. $wpcc_name_field['if_hide'] .'<br> '. __('ID fields separated by commas','wpcc') .': <sup><a title="help" href="http://zetrider.ru/wpcc-help.html?faq='.$type.'_if_hide#'.$type.'_if_hide" target="_blank">?</a></sup></div> <input type="text" name="wpcc_cild[if_hide]" class="input" value="'.wpcc_esc_attr($wpcc_value['if_hide']).'" placeholder="1,2,3,4"><br><div class="clear"></div>';
	$child['if_operator'] 		= '<div class="name">'. $wpcc_name_field['if_operator'] .': <sup><a title="help" href="http://zetrider.ru/wpcc-help.html?faq='.$type.'_if_operator#'.$type.'_if_operator" target="_blank">?</a></sup></div> <select name="wpcc_cild[if_operator]" class="select">'.$select_if_operator.'</select><br><div class="clear"></div>';
	
	$child['armtc_fn'] 			= '<div class="name">'. $wpcc_name_field['armtc_fn'] .'<br> '. __('function is to cover the field braces!','wpcc') .': <sup><a title="help" href="http://zetrider.ru/wpcc-help.html?faq='.$type.'_armtc_fn#'.$type.'_armtc_fn" target="_blank">?</a></sup></div> <select name="wpcc_cild[armtc_fn]" class="select">'.$select_armtc.'</select><br><div class="clear"></div>';
	
	$child['rf_fields'] 		=  '<div class="name">'. $wpcc_name_field['rf_fields'] .': <sup><a title="help" href="http://zetrider.ru/wpcc-help.html?faq='.$type.'_rf_fields#'.$type.'_rf_fields" target="_blank">?</a></sup></div> <input type="text" name="wpcc_cild[rf_fields]" class="input" value="'.wpcc_esc_attr($wpcc_value['rf_fields']).'"><br><div class="clear"></div>';
	
	$child['slider_min'] 		=  '<div class="name">'. $wpcc_name_field['slider_min'] .': <sup><a title="help" href="http://zetrider.ru/wpcc-help.html?faq='.$type.'_slider_min#'.$type.'_slider_min" target="_blank">?</a></sup></div> <input type="text" name="wpcc_cild[slider_min]" class="input" value="'.wpcc_esc_attr($wpcc_value['slider_min']).'"><br><div class="clear"></div>';
	$child['slider_max'] 		= '<div class="name">'. $wpcc_name_field['slider_max'] .': <sup><a title="help" href="http://zetrider.ru/wpcc-help.html?faq='.$type.'_slider_max#'.$type.'_slider_max" target="_blank">?</a></sup></div> <input type="text" name="wpcc_cild[slider_max]" class="input" value="'.wpcc_esc_attr($wpcc_value['slider_max']).'"><br><div class="clear"></div>';
	$child['slider_step'] 		= '<div class="name">'. $wpcc_name_field['slider_step'] .': <sup><a title="help" href="http://zetrider.ru/wpcc-help.html?faq='.$type.'_slider_step#'.$type.'_slider_step" target="_blank">?</a></sup></div> <input type="text" name="wpcc_cild[slider_step]" class="input" value="'.wpcc_esc_attr($wpcc_value['slider_step']).'"><br><div class="clear"></div>';
	$child['slider_position'] 	= '<div class="name">'. $wpcc_name_field['slider_position'] .': <sup><a title="help" href="http://zetrider.ru/wpcc-help.html?faq='.$type.'_slider_position#'.$type.'_slider_position" target="_blank">?</a></sup></div> <select name="wpcc_cild[slider_position]" class="select">'.$select_slider.'</select><br><div class="clear"></div>';
	
	$child_select = $wpcc_type_field[$type]['child'];

	foreach($child_select AS $child_row)
	{
		$return .= $child[$child_row];
		/* If not field */
		if(!array_key_exists($child_row, $wpcc_value))
		{
			$wpdb->query(
				$wpdb->prepare("
				INSERT INTO $wpcc_DB
				(
					wpcc_id, 
					wpcc_field, 
					wpcc_type, 
					wpcc_value, 
					wpcc_order
				) 
				VALUES (
					'%d', 
					'%d', 
					'%s', 
					'%s', 
					'%d'
				)
				", 
					$wpcc_id, 
					$field_id, 
					$child_row, 
					'', 
					'0'
				)
			);
		}
	}
	return $return;
}

function wpcc_arr_options($wpcc_id = '', $option=array())
{
	if(in_array('no_wpcc_id', $option))
	{
		$wpcc_id = '';
	}
	return array(
		'wpcc_submit_'.$wpcc_id,
		'wpcc_text_to_'.$wpcc_id,
		'wpcc_text_af_'.$wpcc_id,
		'wpcc_action_'.$wpcc_id,
		'wpcc_round_sum_'.$wpcc_id,
		'wpcc_mail_check_'.$wpcc_id,
		'wpcc_mail_subject_'.$wpcc_id,
		'wpcc_mail_emailto_'.$wpcc_id,
		'wpcc_mail_text_adm_'.$wpcc_id,
		'wpcc_mail_text_'.$wpcc_id,
		'wpcc_mail_text_success_'.$wpcc_id,
		'wpcc_script_load_post',
		'wpcc_script_load_page',
		'wpcc_theme_'.$wpcc_id
	);
}

function wpcc_setting() {
	global $wpdb, $wpcc_DB, $wpcc_type_field;
	
	$wpcc_section 	= wpcc_esc_attr($_GET['section']);
	$wpcc_id 		= intval($_GET['wpcc_id']);
	$wpcc_delete 	= intval($_GET['delete']);
	$wpcc_delete_f 	= intval($_GET['delete_f']);
	$wpcc_all_arr 	= array();
	
	/* Old Drop */
	if($_GET['action'] == 'old_drop')
	{
		$wpdb->query("DROP TABLE wp_wpcc");
		update_option('wpcc_old_version', '-1');
		$wpcc_updated .= '<p>'. __('Table previous version completely removed','wpcc') .'</p>';
	}
	/* Install */
	if($wpcc_section == 'install')
	{
		$check_old_query = $wpdb->get_results("SHOW TABLES LIKE 'wp_wpcc'");
		if(count($check_old_query))
		{
			$wpcc_updated = '<p><b>'. __('ATTENTION','wpcc') .':</b><br>
			'. __('Table of the previous version is detected. Since version WPCC 3.5 table structure calculator reversed!','wpcc') .'<br>
			'. __('You need to fill out a new calculator again.','wpcc') .'<br>
			'. __('Calculators structure filled in the previous version, you can see','wpcc') .'
			<a href="admin.php?page=wpcc&section=old_version"><b>'. __('here','wpcc') .'</b></a>.<br><br>
			</p>';
			update_option('wpcc_old_version', '1');
		}
		$wpcc_create_tb = $wpdb->query("
		CREATE TABLE IF NOT EXISTS $wpcc_DB (
		id INT NOT NULL AUTO_INCREMENT,
		PRIMARY KEY(id),
		wpcc_id INT NOT NULL DEFAULT '0',
		wpcc_field INT NOT NULL DEFAULT '0',
		wpcc_type VARCHAR(255) NOT NULL,
		wpcc_value TEXT NOT NULL,
		wpcc_order INT NOT NULL DEFAULT '0'
		) ENGINE=MyISAM CHARACTER SET=utf8;
		");
		if($wpdb->last_error != '')
		{
			$wpcc_updated .= '<p>'. __('Error creating table','wpcc') .' '.$wpcc_DB.':<br><b>'.$wpdb->last_error.'</b></p>';
		}
		else
		{
			$wpcc_updated .= '<p>'. __('The new table','wpcc') .' '.$wpcc_DB.' '. __('successfully created.','wpcc') .'</p>';
			$install_success = TRUE;
			update_option('wpcc_version', '3.5');
		}
	}
	
	/* Add New Calculator */
	if(isset($_POST['wpcc_new']))
	{
		$wpcc_max_wpcc_id = $wpdb->get_row("
			SELECT MAX(wpcc_id) AS wpcc_id_max
			FROM $wpcc_DB
		");
		$wpcc_new_id = $wpcc_max_wpcc_id->wpcc_id_max + 1;
				
		$wpdb->query(  
			$wpdb->prepare("
			INSERT INTO $wpcc_DB
			(
				wpcc_id, 
				wpcc_field, 
				wpcc_type, 
				wpcc_value, 
				wpcc_order
			) 
			VALUES (
				'%d', 
				'%d', 
				'%s', 
				'%s', 
				'%d'
			)
			", 
				$wpcc_new_id, 
				'0', 
				'cat', 
				wpcc_esc_attr($_POST['wpcc_value']), 
				'0'
			)
		);
		
		/* Setting Calc */
		update_option( 'wpcc_submit_'.$wpcc_new_id, __('Calculate','wpcc') );
		update_option( 'wpcc_text_to_'.$wpcc_new_id, __('Result','wpcc') );
		update_option( 'wpcc_text_af_'.$wpcc_new_id, __('$','wpcc') );
		update_option( 'wpcc_action_'.$wpcc_new_id, '' );
		update_option( 'wpcc_round_sum_'.$wpcc_new_id, 'none' );
		/* Theme */
		update_option( 'wpcc_theme_'.$wpcc_new_id, 'default' );
		/* Setting Mail */
		update_option( 'wpcc_mail_check_'.$wpcc_new_id, '2' );
		update_option( 'wpcc_mail_subject_'.$wpcc_new_id, __('The calculation of the calculator from the user','wpcc') );
		update_option( 'wpcc_mail_emailto_'.$wpcc_new_id, get_option('admin_email') );
		update_option( 'wpcc_mail_text_adm_'.$wpcc_new_id, __('Calculating the cost of site','wpcc') );
		update_option( 'wpcc_mail_text_'.$wpcc_new_id, __('Send an administrator account?','wpcc') );
		update_option( 'wpcc_mail_text_success_'.$wpcc_new_id, __('Thank you! Your payment is sent! We will contact you soon.','wpcc') );
		update_option( 'wpcc_script_load_post', '0' );
		update_option( 'wpcc_script_load_page', '0' );

		$wpcc_new_result = '
		<div class="wpcc_updated"> 
			<p>'. __('Calculator added', 'wpcc') .', <a href="admin.php?page=wpcc&wpcc_id='.$wpcc_new_id.'">'. __('go to settings', 'wpcc') .'</a></p>
		</div>
		';
	}
	/* Edit Name Calculator */
	if(isset($_POST['wpcc_update']))
	{
		$wpdb->query(  
			$wpdb->prepare("
			UPDATE $wpcc_DB SET 
				wpcc_value = '%s'
			WHERE 
				wpcc_id = '%d'
			AND 
				wpcc_type = 'cat'
			", 
			wpcc_esc_attr($_POST['wpcc_value']), 
			$wpcc_id
			)
		);
		$wpcc_updated .= '<p>'. __('Action completed','wpcc') .'</p>';
	}
	/* Del Calc */
	if($wpcc_delete > '0') {
		$wpdb->query("
		DELETE FROM $wpcc_DB WHERE
			wpcc_id = '$wpcc_delete'
		");
		if($wpcc_id == '0')
		{
			$wpcc_delete_option = wpcc_arr_options($wpcc_delete);
			foreach ($wpcc_delete_option as $wpcc_delete_option_row) {
				delete_option($wpcc_delete_option_row);
			}
			$wpcc_updated .= '<p>'. __('Calculator deleted','wpcc') .'</p>';
		}
	}
	/* Del Field */
	if($wpcc_delete_f > '0') {
		$wpdb->query("
		DELETE FROM $wpcc_DB WHERE
			wpcc_id = '$wpcc_id'
		AND
			wpcc_field = '$wpcc_delete_f'
		");
		$wpcc_updated .= '<p>'. __('Field is removed','wpcc') .'</p>';
	}
	/* Add/Update Row */
	if(isset($_POST['wpcc_add_field']))
	{
		$wpcc_max_var = $wpdb->get_row("
			SELECT MAX(wpcc_order) AS wpcc_order_max, MAX(wpcc_field) AS wpcc_field_max
			FROM $wpcc_DB
			WHERE wpcc_id = '$wpcc_id'
		");
		$wpcc_order = $wpcc_max_var->wpcc_order_max + 1;
		$wpcc_field = $wpcc_max_var->wpcc_field_max + 1;
		
		$wpdb->query(
			$wpdb->prepare("
			INSERT INTO $wpcc_DB
			(
				wpcc_id, 
				wpcc_field, 
				wpcc_type, 
				wpcc_value, 
				wpcc_order
			) 
			VALUES (
				'%d', 
				'%d', 
				'%s', 
				'%s', 
				'%d'
			)
			", 
				$wpcc_id, 
				$wpcc_field, 
				'field_type', 
				wpcc_esc_attr($_POST['wpcc_value']), 
				$wpcc_order
			)
		);
		
		$cild_arr = $wpcc_type_field[$_POST['wpcc_value']]['child'];
		foreach($cild_arr AS $child_row)
		{
			$wpdb->query(
				$wpdb->prepare("
				INSERT INTO $wpcc_DB
				(
					wpcc_id, 
					wpcc_field, 
					wpcc_type, 
					wpcc_value, 
					wpcc_order
				) 
				VALUES (
					'%d', 
					'%d', 
					'%s', 
					'%s', 
					'%d'
				)
				", 
					$wpcc_id, 
					$wpcc_field, 
					$child_row, 
					'', 
					$wpcc_order
				)
			);
		}
	}
	elseif(isset($_POST['wpcc_update_field'])) {
		/* Update Child */
		foreach($_POST['wpcc_cild'] AS $cild_upd_k => $child_upd_v)
		{
			$wpdb->query(  
				$wpdb->prepare("
				UPDATE $wpcc_DB SET 
					wpcc_value = '%s'
				WHERE 
					wpcc_id = '%d'
				AND
					wpcc_field = '%d'
				AND
					wpcc_type = '%s'
				", 
				$child_upd_v,
				$wpcc_id,
				intval($_POST['wpcc_field']),
				$cild_upd_k
				)
			);
		}
		$wpcc_updated .= '<p>'. __('Action completed','wpcc') .'</p>';
	}
	/* Sortable */
	if(isset($_POST['wpcc_sortable']))
	{
		if (isset($_POST['wpcc_sortable_str']) AND $_POST['wpcc_sortable_str'] != '')
		{
			$wpcc_sortable_str 		= $_POST['wpcc_sortable_str'];
			$wpcc_sortable_arr 		= explode(",", $wpcc_sortable_str);
			$wpcc_sortable_count 	= count($wpcc_sortable_arr);
			for($i_sortable = 0; $i_sortable < $wpcc_sortable_count; $i_sortable++)
			{
				$str_sortable = str_replace("wpcc_sortable_", "", $wpcc_sortable_arr[$i_sortable]);
				$wpdb->query($wpdb->prepare("UPDATE $wpcc_DB SET wpcc_order = %d WHERE id = %d ", $i_sortable, $str_sortable));
			}
			$wpcc_updated .= '<p>'. __('The field order is saved','wpcc') .'</p>';
		}
	}
	/* Arr All Calc */
	$wpcc_a = $wpdb->get_results("SELECT wpcc_id, wpcc_value FROM $wpcc_DB WHERE wpcc_type = 'cat'");
	if(count($wpcc_a) > '0')
	{
		foreach($wpcc_a as $wpcc_a_r)
		{
			$wpcc_all_arr [$wpcc_a_r->wpcc_id]= array(
				'wpcc_id' => $wpcc_a_r->wpcc_id,
				'wpcc_name' => $wpcc_a_r->wpcc_value
			);
		}
	}
?>
<div class="wrap wpcc_wrap">
	<div class="jq_wpcc_setting" data-plugin_url="<?php echo WPCC_PLUGIN_URL; ?>" data-wpcc_id="<?php echo $wpcc_id; ?>"></div>
	
	<h2>WPCC 3.5</h2>
	
	<div class="zetrider">
		<a href="http://zetrider.ru" target="_blank" class="site"><b>ZETRIDER</b><span>web developer</span></a>
		<a href="http://zetrider.ru/donate" target="_blank" class="thanks"></a>
	</div>
	
	<?php
	echo (($wpcc_updated != '')?'<div class="wpcc_updated wpcc_updated_top">'.$wpcc_updated.'</div>':'');
	if(get_option('wpcc_version', '1') < '3.5' AND $install_success != TRUE)
	{
		echo '<a href="admin.php?page=wpcc&section=install" class="button button-primary">'. __('Install calculator','wpcc') .'</a>';
	}
	else
	{
	echo ((get_option('wpcc_old_version') == '1')?'<a href="admin.php?page=wpcc&section=old_version" class="button button-primary '.(($wpcc_section == 'old_version')?'active':'').'">'. __('The previous version','wpcc') .'</a>':''); 
	?>
	<a href="admin.php?page=wpcc" class="button button-primary <?php echo (($wpcc_section == '' AND $wpcc_id == '0')?'active':''); ?>"><?php _e('List of calculators', 'wpcc'); ?></a>
	<a href="admin.php?page=wpcc&section=new" class="button button-primary <?php echo (($wpcc_section == 'new')?'active':''); ?>"><?php _e('New calculator', 'wpcc'); ?></a>
	<?php
	}
	?>
	<div class="clear"></div>
	<br>
	
<?php
if($wpcc_section == 'old_version')
{
	include_once('action/wpcc_old.php');
	echo wpcc_old_35();
}
if($wpcc_id > '0' AND is_array($wpcc_all_arr[$wpcc_id]))
{
?>
	<a href="admin.php?page=wpcc&wpcc_id=<?php echo $wpcc_id; ?>" class="button button-primary <?php echo (($wpcc_section == '')?'active':''); ?>"><?php _e('Constructor fields', 'wpcc'); ?></a>
	<a href="admin.php?page=wpcc&wpcc_id=<?php echo $wpcc_id; ?>&section=export" class="button button-primary <?php echo (($wpcc_section == 'export')?'active':''); ?>"><?php _e('Export formula', 'wpcc'); ?></a>
	<a href="admin.php?page=wpcc&wpcc_id=<?php echo $wpcc_id; ?>&section=import" class="button button-primary <?php echo (($wpcc_section == 'import')?'active':''); ?>"><?php _e('Import formula', 'wpcc'); ?></a>
	<a href="admin.php?page=wpcc&wpcc_id=<?php echo $wpcc_id; ?>&section=setting" class="button button-primary <?php echo (($wpcc_section == 'setting')?'active':''); ?>"><?php _e('Settings', 'wpcc'); ?></a>
	<br><br>
	<form class="form" method="POST">
		<b><?php _e('Shortcode', 'wpcc'); ?>:</b> [wpcc id="<?php echo $wpcc_id; ?>"]
		<br>
		<input type="hidden" name="wpdb_id" value="<?php echo $wpcc_id; ?>">
		<input type="hidden" name="wpcc_field" value="0">
		<input type="hidden" name="wpcc_type" value="cat">
		<input type="text" name="wpcc_value" class="input" value="<?php echo $wpcc_all_arr[$wpcc_id]['wpcc_name']; ?>" placeholder="<?php _e('Name calculator', 'wpcc'); ?>">
		<input type="hidden" name="wpcc_order" value="0">
		<input type="submit" name="wpcc_update" value="<?php _e('Change', 'wpcc'); ?>" class="button button-primary">
	</form>
<?php
	if($wpcc_section == 'setting')
	{
?>
		<br>
		<form method="post" action="options.php" class="wpcc_type" >
			<?php
			wp_nonce_field('update-options');
			$wpcc_submit_id 			= 'wpcc_submit_'.$wpcc_id;
			$wpcc_text_to_id 			= 'wpcc_text_to_'.$wpcc_id;
			$wpcc_text_af_id 			= 'wpcc_text_af_'.$wpcc_id;
			$wpcc_action_id 			= 'wpcc_action_'.$wpcc_id;
			$wpcc_round_sum_id 			= 'wpcc_round_sum_'.$wpcc_id;
			$wpcc_theme_id 				= 'wpcc_theme_'.$wpcc_id;
			$wpcc_mail_check_id 		= 'wpcc_mail_check_'.$wpcc_id;
			$wpcc_mail_subject_id 		= 'wpcc_mail_subject_'.$wpcc_id;
			$wpcc_mail_emailto_id 		= 'wpcc_mail_emailto_'.$wpcc_id;
			$wpcc_mail_text_adm_id		= 'wpcc_mail_text_adm_'.$wpcc_id;
			$wpcc_mail_text_id 			= 'wpcc_mail_text_'.$wpcc_id;
			$wpcc_mail_text_success_id 	= 'wpcc_mail_text_success_'.$wpcc_id;
			$wpcc_script_load_post 		= 'wpcc_script_load_post';
			$wpcc_script_load_page 		= 'wpcc_script_load_page';
			?>
			<h3><?php _e('Settings calculator', 'wpcc'); ?></h3>
			<div class="name"><?php _e('Button name', 'wpcc'); ?>:</div> <input type="text" name="<?php echo $wpcc_submit_id; ?>" class="input" value="<?php echo get_option($wpcc_submit_id); ?>"><div class="clear"></div><br>
			<div class="name"><?php _e('The text before the sum', 'wpcc'); ?>:</div> <input type="text" name="<?php echo $wpcc_text_to_id; ?>" class="input" value="<?php echo get_option($wpcc_text_to_id); ?>"><div class="clear"></div><br>
			<div class="name"><?php _e('Text after the amount', 'wpcc'); ?>:</div> <input type="text" name="<?php echo $wpcc_text_af_id; ?>" class="input" value="<?php echo get_option($wpcc_text_af_id); ?>"><div class="clear"></div><br>
			<div class="name"><?php _e('Action form', 'wpcc'); ?>:</div> <input type="text" name="<?php echo $wpcc_action_id; ?>" class="input" value="<?php echo get_option($wpcc_action_id); ?>"><div class="clear"></div><br>
			<div class="name"><?php _e('Rounding amount', 'wpcc'); ?>:</div>
			<select name="<?php echo $wpcc_round_sum_id; ?>" class="input">
				<?php
				$wpcc_round_sum = array(
					'none' 		=> __('Do not round', 'wpcc'),
					'round' 	=> __('Rounding ROUND() function 0 characters. Example, 4 = 3.7, 3.1 = 3', 'wpcc'),
					'round_1' 	=> __('Rounding ROUND() function 1 character. Example: 3.46 = 3.5', 'wpcc'),
					'round_2' 	=> __('Rounding ROUND() function 2 characters. Example: 3.467 = 3.47', 'wpcc'),
					'round_3' 	=> __('Rounding ROUND() function 3 digits. Example: 3.4678 = 3.468', 'wpcc'),
					'round_4' 	=> __('Rounding ROUND() function 4 digits. Example: 3.46789 = 3.4679', 'wpcc'),
					'ceil' 		=> __('Rounding function CEIL(). Example: 4 = 3.7, 3.1 = 4', 'wpcc'),
					'floor' 	=> __('Rounding function FLOOR(). Example: 3.7 = 3, 3.1 = 3', 'wpcc')
				);
				foreach($wpcc_round_sum as $wpcc_round_sum_k => $wpcc_round_sum_v)
				{
					echo '<option value="'.$wpcc_round_sum_k.'" '.((get_option($wpcc_round_sum_id) == $wpcc_round_sum_k)?'selected':'').'>'.$wpcc_round_sum_v.'</option>';
				}
				?>
			</select>
			<div class="clear"></div><br>
			
			<div class="name"><?php _e('Design calculator', 'wpcc'); ?>:</div> 
			<select name="<?php echo $wpcc_theme_id;?>" class="input">
				<?php
				$wpcc_themes_arr = array(
					'default' 		=> __('Standard', 'wpcc'),
					'light_shadows' => __('The light from the shadows', 'wpcc'),
					'bulk' 			=> __('Bulk', 'wpcc'),
					'striped' 			=> __('Striped', 'wpcc')
				);
				foreach($wpcc_themes_arr as $wpcc_themes_k => $wpcc_themes_v)
				{
					echo '<option value="'.$wpcc_themes_k.'" '.((get_option($wpcc_theme_id) == $wpcc_themes_k)?'selected':'').'>'.$wpcc_themes_v.'</option>';
				}
				?>
			</select>
			<div class="clear"></div><br>
		
			<h3><?php _e('Setting Mail', 'wpcc'); ?></h3>
			<div class="name"><?php _e('Enable Send E-Mail', 'wpcc'); ?></div>
			<select name="<?php echo $wpcc_mail_check_id; ?>" class="input">
				<option value="1" <?php if(get_option($wpcc_mail_check_id) == '1') { echo 'selected'; } ?>><?php _e('Yes', 'wpcc'); ?></option>
				<option value="2" <?php if(get_option($wpcc_mail_check_id) == '2') { echo 'selected'; } ?>><?php _e('No', 'wpcc'); ?></option>
			</select>
			<br><br>
			<div class="name"><?php _e('Subject', 'wpcc'); ?>:</div> <input type="text" name="<?php echo $wpcc_mail_subject_id; ?>" class="input" value="<?php echo wpcc_esc_attr(get_option($wpcc_mail_subject_id)); ?>"><div class="clear"></div><br>
			<div class="name"><?php _e('For how to send E-Mail', 'wpcc'); ?>:</div> <input type="text" name="<?php echo $wpcc_mail_emailto_id; ?>" class="input" value="<?php echo wpcc_esc_attr(get_option($wpcc_mail_emailto_id)); ?>"><div class="clear"></div><br>
			<div class="name"><?php _e('The text of a letter', 'wpcc'); ?>:</div> <textarea name="<?php echo $wpcc_mail_text_adm_id; ?>" class="textarea"><?php echo wpcc_esc_attr(get_option($wpcc_mail_text_adm_id)); ?></textarea><div class="clear"></div><br>
			<div class="name"><?php _e('The text before sending form', 'wpcc'); ?>:</div> <textarea name="<?php echo $wpcc_mail_text_id; ?>" maxlength="65535" class="textarea"><?php echo wpcc_esc_attr(get_option($wpcc_mail_text_id)); ?></textarea><div class="clear"></div><br>
			<div class="name"><?php _e('Message sent successfully', 'wpcc'); ?>:</div> <textarea name="<?php echo $wpcc_mail_text_success_id; ?>" class="textarea"><?php echo wpcc_esc_attr(get_option($wpcc_mail_text_success_id)); ?></textarea><div class="clear"></div><br>
			
			<h3><?php _e('Loading Script Plugin', 'wpcc'); ?></h3>
			<small>
			<?php _e('In order not to load the plugin scripts on all pages (jquery-ui-core, jquery-ui-slider, wpcc.js) <br> can specify the ID records and pages separated by commas in the fields below. <br> Enter 0 if you need to download scripts on all pages of the site. <br> <b> settings apply to all calculators </b>', 'wpcc'); ?>
			<br><br>
			</small>
			<div class="clear"></div>
			<div class="name"><?php _e('IDs Posts', 'wpcc'); ?></div>
			<input type="text" name="<?php echo $wpcc_script_load_post; ?>" class="input" value="<?php echo get_option($wpcc_script_load_post); ?>">
			<div class="clear"></div><br>
			
			<div class="name"><?php _e('IDs Pages', 'wpcc'); ?></div>
			<input type="text" name="<?php echo $wpcc_script_load_page; ?>" class="input" value="<?php echo get_option($wpcc_script_load_page); ?>">
			<div class="clear"></div><br>
			
			<div class="clear"></div><br>
			<input type="hidden" name="action" value="update">
			<input type="hidden" name="page_options" value="<?php echo $wpcc_submit_id.','.$wpcc_text_to_id.','.$wpcc_text_af_id.','.$wpcc_action_id.','.$wpcc_round_sum_id.','.$wpcc_theme_id.','.$wpcc_mail_check_id.','.$wpcc_mail_subject_id.','.$wpcc_mail_emailto_id.','.$wpcc_mail_text_adm_id.','.$wpcc_mail_text_id.','.$wpcc_mail_text_success_id.','.$wpcc_script_load_post.','.$wpcc_script_load_page; ?>">
			<input type="submit" name="update" value="<?php _e('Save', 'wpcc'); ?>" class="button-primary">
		</form>
<?php
	}
	elseif($wpcc_section == 'export')
	{
		echo '
		<h2>'. __('Export array formula', 'wpcc') .'</h2>
		<div class="wpcc_updated"> 
			<p>
				'. __('Select all the contents of the fields below and export to a new calculator.', 'wpcc') .'
			</p>
		</div>
		';
		/* Fields */
		$wpcc_export = $wpdb->get_results("SELECT * FROM $wpcc_DB WHERE wpcc_id = '$wpcc_id' AND wpcc_type != 'cat' ORDER BY wpcc_order");
		if(count($wpcc_export) > '0') {
			foreach($wpcc_export as $wpcc_export_row) {				
				if($wpcc_export_row->wpcc_type == 'sess_calc_id')
				{
					$wpcc_export_value = '/*WPCC_ID*/';
				}
				elseif($wpcc_export_row->wpcc_type == 'text')
				{
					$wpcc_export_value = preg_replace("|\[session id=\"(.*)\"\](.*)\[/session\]|", "[session id=\"/*WPCC_ID*/\"]$2[/session]", stripslashes($wpcc_export_row->wpcc_value));
				}
				else
				{
					$wpcc_export_value = $wpcc_export_row->wpcc_value;
				}
				
				$wpcc_export_fields ['wpcc_fields'][] = array(
					'wpcc_field' 	=> stripslashes($wpcc_export_row->wpcc_field),
					'wpcc_type' 	=> stripslashes($wpcc_export_row->wpcc_type),
					'wpcc_value' 	=> stripslashes($wpcc_export_value),
					'wpcc_order' 	=> stripslashes($wpcc_export_row->wpcc_order),
				);
				
			}
			/* Options */
			$wpcc_export_get_options = wpcc_arr_options($wpcc_id, array('no_wpcc_id'));
			foreach($wpcc_export_get_options AS $wpcc_export_options_row)
			{
				$wpcc_export_options ['wpcc_options'][] = array(
					$wpcc_export_options_row => get_option($wpcc_export_options_row.$wpcc_id)
				);
			}
			$wpcc_export_array_merge = array_merge($wpcc_export_fields, $wpcc_export_options);
			echo '
			<textarea class="wpcc_export">'.serialize($wpcc_export_array_merge).'</textarea>
			<a href="admin.php?page=wpcc&wpcc_id='.$wpcc_id.'" class="button button-primary">'. __('Cancel', 'wpcc') .'</a>
			';
		} else {
			echo '<p>'. __('Your formula is empty', 'wpcc') .'</p>';
		}
	}
	elseif($wpcc_section == 'import')
	{
		echo '
		<h2>'. __('Importing an array formula', 'wpcc') .'</h2>
		<div class="wpcc_updated"> 
			<p>
				'. __('Paste the entire array of data calculator and click the Import button.', 'wpcc') .'
			</p>
		</div>
		<form method="POST">
			<textarea name="wpcc_import" class="wpcc_import"></textarea>
			<input type="submit" name="wpcc_insert_import" value="'. __('Import', 'wpcc') .'" class="button button-primary">
			<a href="admin.php?page=wpcc&wpcc_id='.$wpcc_id.'" class="button button-primary">'. __('Cancel', 'wpcc') .'</a>
		</form>
		';
		$wpcc_import = unserialize(stripslashes($_POST['wpcc_import']));
	
		if(is_array($wpcc_import))
		{
			/* Import Fields */
			foreach($wpcc_import['wpcc_fields'] AS $wpcc_import_arr)
			{
			
				if(in_array($wpcc_import_arr['wpcc_type'], array('sess_calc_id', 'text')))
				{
					$wpcc_import_value = str_replace('/*WPCC_ID*/', $wpcc_id, $wpcc_import_arr['wpcc_value']);
				}
				else
				{
					$wpcc_import_value = $wpcc_import_arr['wpcc_value'];
				}
				$wpdb->query(  
					$wpdb->prepare("
					INSERT INTO $wpcc_DB
					(
						wpcc_id, 
						wpcc_field, 
						wpcc_type, 
						wpcc_value, 
						wpcc_order
					) 
					VALUES (
						'%d', 
						'%d', 
						'%s', 
						'%s', 
						'%d'
					)
					", 
						$wpcc_id, 
						$wpcc_import_arr['wpcc_field'], 
						$wpcc_import_arr['wpcc_type'], 
						$wpcc_import_value, 
						$wpcc_import_arr['wpcc_order']
					)
				);
			}
			/* Import Fields */
			foreach($wpcc_import['wpcc_options'] AS $wpcc_import_arr)
			{
				foreach($wpcc_import_arr AS $wpcc_import_k => $wpcc_import_v)
				{
					update_option( $wpcc_import_k.$wpcc_id, $wpcc_import_v );
				}
			}
			$wpcc_updated .= '<p>'. __('Import completed','wpcc') .'</p>';
		}
	}
	else
	{
?>
	<br>
	<form class="form" action="admin.php?page=wpcc&wpcc_id=<?php echo $wpcc_id; ?>" method="POST">
		<select class="wpcc_menu" name="wpcc_value">
			<?php
			foreach($wpcc_type_field AS $wpcc_menu_k => $wpcc_menu_v)
			{
				echo '<option value="'.$wpcc_menu_k.'">'.$wpcc_menu_v['name'].'</option>';
			}
			?>
		</select>
		<input type="submit" name="wpcc_add_field" value="<?php _e('Add', 'wpcc'); ?>" class="button button-primary">
	</form>
	<br>
		
	<h2><?php _e('Added fields', 'wpcc'); ?></h2>
	<div class="wpcc_fields">
		<?php	
		$wpcc_row_arr = $wpdb->get_results("SELECT * FROM $wpcc_DB WHERE wpcc_id = '$wpcc_id' AND wpcc_type != 'cat' ORDER BY wpcc_order");
		if(count($wpcc_row_arr) > '0') {
			echo '<ul>';
			foreach($wpcc_row_arr as $wpcc_row) {
				$wpcc_value = wpcc_cache_field($wpcc_row_arr, $wpcc_row->wpcc_field);
				if($wpcc_row->wpcc_type == 'field_type')
				{
					echo '
				<li id="wpcc_sortable_'.$wpcc_row->id.'" class="button button-small wpcc_type">
					<div class="ico"></div>
					[ID-'.$wpcc_row->wpcc_field.']
					'.$wpcc_type_field[$wpcc_row->wpcc_value]['name'].''.(($wpcc_value['title'] != '')?' ( '.mb_substr($wpcc_value['title'], 0, '80').' )':'').'
					<form method="post" class="setting">
						'.wpcc_row_field($wpcc_row->wpcc_value, $wpcc_row_arr, $wpcc_row->wpcc_field).'
						<input type="hidden" name="wpcc_field" value="'.$wpcc_row->wpcc_field.'">
						<input type="submit" name="wpcc_update_field" value="'. __('Update', 'wpcc') .'" class="button-primary">
						<a href="admin.php?page=wpcc&wpcc_id='.$wpcc_id.'&delete_f='.$wpcc_row->wpcc_field.'" class="button-primary">'. __('Delete', 'wpcc') .'</a>
					</form>
				</li>
					';
				}
			}
			echo '
			</ul>
			<div class="wpcc_updated wpcc_sortable"> 
				<p>
					'. __('Sort the order of the fields with the mouse.', 'wpcc') .'
				</p>
				<form method="post">
					<input type="hidden" class="jq_wpcc_sortable" name="wpcc_sortable_str" />
					<input type="submit" name="wpcc_sortable" class="button-primary" value="'. __('Save the order of the fields', 'wpcc') .'" />
				</form>
				<div class="clear"></div>
			</div>
			';
		} else {
			echo __("Formula is empty", "wpcc");
		}
		?>
	</div>
	
	<h2><?php _e('Text formula ID fields', 'wpcc'); ?></h2>
	<?php
	$wpcc_text = $wpdb->get_results("SELECT * FROM $wpcc_DB WHERE wpcc_id = '$wpcc_id' AND wpcc_type != 'cat' ORDER BY wpcc_order");
	if(count($wpcc_text) > '0') {
		foreach($wpcc_text as $wpcc_text_row) {
			$wpcc_text_cache = wpcc_cache_field($wpcc_text, $wpcc_text_row->wpcc_field);
			if($wpcc_text_row->wpcc_type == 'field_type' AND !in_array($wpcc_text_row->wpcc_value, array('textblock', 'if')) AND $wpcc_text_cache['exclude'] != '2')
			{
				echo $wpcc_text_cache['signto'].(($wpcc_text_row->wpcc_value == 'armtc')?'[':'').$wpcc_text_row->wpcc_field.(($wpcc_text_row->wpcc_value == 'armtc')?']':'').$wpcc_text_cache['signaf'];
			}
		}
	} else {
		_e('Formula is empty', 'wpcc');
	}
	?>
	
	<h2><?php _e('Preview calculator', 'wpcc'); ?></h2>
	<div class="wpcc_form_calc">
			<?php echo do_shortcode('[wpcc id="'.$wpcc_id.'" moderator="true"]'); ?>
	</div>
	
<?php
	}
}
elseif($wpcc_section == '')
{
	if(count($wpcc_all_arr) == '0')
	{
		echo '
		<div class="wpcc_updated"> 
			<p>'. __('You have not added any calculator', 'wpcc') .'</p>
		</div>
		';
	}
	else
	{
		echo '
		<div class="list">';
		foreach($wpcc_all_arr AS $wpcc_all_list)
		{
			echo '
			<div class="button button-small">
				<a href="admin.php?page=wpcc&wpcc_id='.$wpcc_all_list['wpcc_id'].'">'.$wpcc_all_list['wpcc_id'].' - '.$wpcc_all_list['wpcc_name'].'</a>
				<a href="admin.php?page=wpcc&delete='.$wpcc_all_list['wpcc_id'].'" class="alignright">['. __('Delete', 'wpcc') .']</a>
			</div>
			';
		}
		echo '</div>';
	}
}
elseif($wpcc_section == 'new')
{
	if($wpcc_new_result != '')
	{
		echo $wpcc_new_result;
	}
	else
	{
?>
<form class="form" method="POST">
	<input type="hidden" name="wpdb_id" value="0">
	<input type="hidden" name="wpcc_field" value="0">
	<input type="hidden" name="wpcc_type" value="cat">
	<input type="text" name="wpcc_value" class="input" value="<?php echo wpcc_esc_attr($_POST['wpcc_value']); ?>" placeholder="<?php _e('Name calculator', 'wpcc'); ?>">
	<input type="hidden" name="wpcc_order" value="0">
	<input type="submit" name="wpcc_new" value="<?php _e('Add', 'wpcc'); ?>"  class="button button-primary">
</form>
<?php
	}
}
?>
	<div class="clear"></div>
</div>
<?php
}

function WPCC_Widget_function($wpcc_id) {
	$wpcc_id = intval($wpcc_id);
	if($wpcc_id > '0') {
		$return .= do_shortcode('[wpcc id="'.$wpcc_id.'" container="sidebar"]');
	} else {
		$return = __('Not selected ID calculator.', 'wpcc');
	}
	return $return;
}
class WPCC_Widget extends WP_Widget {
	function WPCC_Widget() {	parent::WP_Widget(false, $name = 'WPCC Widget');	}
	function widget($args, $instance) {
		extract( $args );
		if($instance['title'] != '')
		{
			echo $before_title;
			echo $instance['title'];
			echo $after_title;
		}
		echo $before_widget;
		echo WPCC_Widget_function($instance['wpcc_id']);
		echo $after_widget;
	}
	function update($new_instance, $old_instance) {	return $new_instance; }
	function form($instance) {
	global $wpdb, $wpcc_DB;
	$title = esc_attr($instance['title']);
	$wpcc_id = esc_attr($instance['wpcc_id']);

?>
	<p>
		<label for="<?php echo $this->get_field_id('title'); ?>"><?php _e('Title', 'wpcc'); ?>
		<input class="widefat" id="<?php echo $this->get_field_id('title'); ?>" name="<?php echo $this->get_field_name('title'); ?>" type="text" value="<?php echo $title; ?>" />
		</label>
	</p>
	
	<p>
		<label><?php _e('Calculator', 'wpcc'); ?>:</label>
		<select name="<?php echo $this->get_field_name('wpcc_id'); ?>" style="width:170px;">
			<option value="0"><?php _e('Select the calculator', 'wpcc'); ?></option>
			<?php
			$wpcc_a = $wpdb->get_results("SELECT wpcc_id, wpcc_value FROM $wpcc_DB WHERE wpcc_type = 'cat'");
			if(count($wpcc_a) > '0')
			{
				foreach($wpcc_a as $wpcc_a_r)
				{
					echo '<option value="'.$wpcc_a_r->wpcc_id.'" '.(($wpcc_a_r->wpcc_id == $wpcc_id)?'selected':'').' >[ID-'.$wpcc_a_r->wpcc_id.'] '.$wpcc_a_r->wpcc_value.'</option>';
				}
			}
			?>
		</select>
	</p>
<?php
	}
}
add_action('widgets_init', create_function('', 'return register_widget("WPCC_Widget");'));

function wpcc_if_parse($wpcc_id) {
	global $wpdb, $wpcc_DB;
	
	$return = array(
		'if_hide' => array(),
		'if_show' => array()
	);
	$return_if_hide = array();
	$return_if_show = array();
	
	$if_structure = $_POST['wpcc_structure_if'];
	if(count($if_structure) > '0')
	{
		foreach($if_structure as $if_k)
		{
			$if_list [] = preg_replace ('/[^0-9]/', '', $if_k);
		}
		$field_id = implode("','", $if_list);
		
		$if_res = $wpdb->get_results("
			SELECT * FROM $wpcc_DB 
			WHERE
				wpcc_id = '$wpcc_id'
			AND
				wpcc_field IN ('$field_id')
		");
		foreach($if_res AS $if_row)
		{
			$if_cache = wpcc_cache_field($if_res, $if_row->wpcc_field);
			if($if_row->wpcc_type == 'field_type')
			{
				$if_v = $_POST['wpcc_structure'][$if_cache['if_id']];
				
				$if_value 	= ((is_array($if_v))?implode('', $if_v):wpcc_esc_attr($if_v));
				
				$if_operator = (($if_cache['if_operator'] == '')?'==':$if_cache['if_operator']);
				
				if(
					( $if_operator == '==' AND $if_value == $if_cache['if_val'] )
					||
					( $if_operator == '>=' AND $if_value >= $if_cache['if_val'] )
					||
					( $if_operator == '<=' AND $if_value <= $if_cache['if_val'] )
					||
					( $if_operator == '>' AND $if_value > $if_cache['if_val'] )
					||
					( $if_operator == '<' AND $if_value < $if_cache['if_val'] )
				)
				{
					$return_if_hide[] = (($if_cache['if_hide'] == '')?'0':$if_cache['if_hide']);
					$return_if_show[] = (($if_cache['if_show'] == '')?'0':$if_cache['if_show']);
				}
				else
				{
					$return_if_hide[] = (($if_cache['if_show'] == '')?'0':$if_cache['if_show']);
					$return_if_show[] = (($if_cache['if_hide'] == '')?'0':$if_cache['if_hide']);
				}
			}
		}
		/* переделать ... */
		$if_hide_str_im = implode(',',$return_if_hide);
		$if_show_str_im = implode(',',$return_if_show);
		
		$return['if_hide'] = explode(',',$if_hide_str_im);
		$return['if_show'] = explode(',',$if_show_str_im);
	}
	
	return $return;
}

function wpcc_result($POST, $moderator='false') {
	$wpcc_id = intval($POST['wpcc_id']);
	$return = '
	<div class="wpcc_result wpcc_result_'.$wpcc_id.'" id="wpcc_result">
	';
		
		$wpcc_parsing_post = wpcc_parsing_post($POST);
		
		if(!empty($wpcc_parsing_post))
		{
			foreach($wpcc_parsing_post as $eval_row)
			{
				$eval_return .= $eval_row;
			}
		}
		else
		{
			$eval_return = '0';
		}
		
		$return .= get_option('wpcc_text_to_'.$wpcc_id).' ';
		eval('$wpcc_sum = '.$eval_return.';');
		
		/* Round */
		$wpcc_round = get_option('wpcc_round_sum_'.$wpcc_id);
		if($wpcc_round == 'round')
		{
			$wpcc_sum = round($wpcc_sum);
		}
		elseif($wpcc_round == 'round_1')
		{
			$wpcc_sum = round($wpcc_sum, 1);
		}
		elseif($wpcc_round == 'round_2')
		{
			$wpcc_sum = round($wpcc_sum, 2);
		}
		elseif($wpcc_round == 'round_3')
		{
			$wpcc_sum = round($wpcc_sum, 3);
		}
		elseif($wpcc_round == 'round_4')
		{
			$wpcc_sum = round($wpcc_sum, 4);
		}
		elseif($wpcc_round == 'ceil')
		{
			$wpcc_sum = ceil($wpcc_sum);
		}
		elseif($wpcc_round == 'floor')
		{
			$wpcc_sum = floor($wpcc_sum);
		}
		
		$_SESSION['wpcc_'.$wpcc_id]['sum'] = $wpcc_sum;
		
		$return .= $wpcc_sum;
		
		$return .= ' '.get_option('wpcc_text_af_'.$wpcc_id).'';
		
		$return .= '
	</div>
	';
	
	if ($moderator == 'true' OR $POST['wpcc_moderator'] == 'true') {
		echo '
		<br>
		<hr>
		<p>'. __('These are only visible in the backend', 'wpcc') .'</p>
		<h3>'. __('Line', 'wpcc') .':</h3>
		';
		wpcc_print_r($eval_return);
		echo '<h3>$_SESSION[\'wpcc_'.$wpcc_id.'\']:</h3>';
		wpcc_print_r($_SESSION['wpcc_'.$wpcc_id]);
		echo '<h3>ksort(array()):</h3>';
		wpcc_print_r($wpcc_parsing_post);
		echo '<hr>';
	}
	
	return $return;
}

/* WPCC ShortCode */
function wpcc_shortcode($atts) {
	global $wpdb, $wpcc_DB;
	extract(
		shortcode_atts(
			array(
				'id' => '1', 
				'moderator' => 'false',
				'container' => 'page'
			), $atts
		)
	);
		
	$return 		= '';
	$wpcc_id 		= intval($id);
	$wpcc_action 	= get_option('wpcc_action_'.$wpcc_id);
	$wpcc_submit 	= get_option('wpcc_submit_'.$wpcc_id);
	$wpcc_theme 	= get_option('wpcc_theme_'.$wpcc_id);
	$wpcc_structure_id = array();
	$wpcc_clear 	= '<div class="clear"></div>';
	
	
	$res = $wpdb->get_results("SELECT * FROM $wpcc_DB WHERE wpcc_id = '$wpcc_id' AND wpcc_type != 'cat' ORDER BY wpcc_order");

	if (count($res) == '0')
	{
		$return .= __("Formula is empty", "wpcc")."<br>"; 
	}
	else
	{
		$return .= '
'.(($wpcc_theme != '')?'<link rel="stylesheet" href="' . WPCC_PLUGIN_URL . '/theme/'.$wpcc_theme.'/style.css" type="text/css" media="screen">':'').'
<script type="text/javascript" src="' . WPCC_PLUGIN_URL . '/js/wpcc.js?'.filemtime( WPCC_PLUGIN_DIR . '/js/wpcc.js' ).'"></script>
<div class="wpcc wpcc_'.$wpcc_id.' '.(($container == 'sidebar')?'wpcc_widget':'').'">
	<form method="POST" action="'.(($wpcc_action == '')?'#wpcc_result':'').'" class="wpcc_form wpcc_form_'.$wpcc_id.' '.((isset($_POST['wpcc_calculate']))?'wpcc_submit_isset':'').'">
	';

		/* IF FIELD	*/
		$wpcc_form_if_hide = array();
		$wpcc_form_if_show = array();
		$wpcc_if_parse = wpcc_if_parse($wpcc_id);
		if(count($wpcc_if_parse['if_hide']) > '0')
		{
			$wpcc_form_if_hide = $wpcc_if_parse['if_hide'];
		}
		if(count($wpcc_if_parse['if_show']) > '0')
		{
			$wpcc_form_if_show = $wpcc_if_parse['if_show'];
		}
		/* IF FIELD END */
		
		foreach ($res as $row)
		{
			if($row->wpcc_type == 'field_type')
			{
				$wpcc_cache_field = wpcc_cache_field($res, $row->wpcc_field);
				$select_arr 		= '';
				$input_val_arr 		= '';
				$radio_i 			= '';
				$if_show_id 		= '';
				$if_hide_id 		= '';
				$wpcc_if_display 	= '';
				
				if(in_array($row->wpcc_field, $wpcc_form_if_hide))
				{
					$wpcc_if_display = 'none';
				}
				elseif(in_array($row->wpcc_field, $wpcc_form_if_show))
				{
					$wpcc_if_display = 'block';
				}
				elseif($wpcc_cache_field['hidden_display'] == '1')
				{
					$wpcc_if_display = 'none';
				}
				else
				{
					$wpcc_if_display = 'block';
				}
					
				if ($row->wpcc_value == "if")
				{
					$if_show_id = (($wpcc_cache_field['if_show'] == '')?'0':$wpcc_cache_field['if_show']);
					$if_hide_id = (($wpcc_cache_field['if_hide'] == '')?'0':$wpcc_cache_field['if_hide']);
					$return .= '
			<div class="wpcc_jq_if" data-if_id="'.$wpcc_cache_field['if_id'].'" data-val="'.wpcc_esc_attr($wpcc_cache_field['if_val']).'" data-show="'.$if_show_id.'" data-hide="'.$if_hide_id.'" data-operator="'.(($wpcc_cache_field['if_operator'] == '')?'==':$wpcc_cache_field['if_operator']).'"></div>				
			<input type="hidden" name="wpcc_structure_if[]" value="'.$row->wpcc_field.'">
			';

				}
				
				if ($row->wpcc_value == "textblock")
				{					
					$return .= '
			<div class="wpcc_box wpcc_box_'.$row->wpcc_field.' wpcc_jq_if_'.$row->wpcc_field.'" style="display: '.$wpcc_if_display.';">
				<div class="wpcc_description '.(($wpcc_cache_field['title'] == '')?'wpcc_description_empty':'').'">'.$wpcc_cache_field['title'].'</div>
				<div class="wpcc_text wpcc_text_'.$row->wpcc_field.'">
					'.preg_replace("|\[session id=\"(.*)\"\](.*)\[/session\]|e", "\$_SESSION['wpcc_\\1']['\\2']", stripslashes(nl2br($wpcc_cache_field['text']))).'
				</div>
			'.$wpcc_clear.'</div>
			';
				}
			
				if ($row->wpcc_value == "select")
				{
					$return .= '
			<div class="wpcc_box wpcc_box_'.$row->wpcc_field.' wpcc_jq_if_'.$row->wpcc_field.'" style="display: '.$wpcc_if_display.';">
				<div class="wpcc_description '.(($wpcc_cache_field['title'] == '')?'wpcc_description_empty':'').'">'.$wpcc_cache_field['title'].'</div>
				<select name="wpcc_structure['.$row->wpcc_field.']" class="wpcc_select wpcc_select_'.$row->wpcc_field.' wpcc_jq_'.$row->wpcc_field.'" data-type="'.$row->wpcc_value.'">';
					
					if($wpcc_cache_field['list'] != '')
					{
						$select_arr = preg_split('/\\r\\n?|\\n/', $wpcc_cache_field['list']);
						foreach ($select_arr as $select_row)
						{
							$input_val_arr = explode(':',$select_row);
							$return .= '
					<option value="'.$input_val_arr[0].'" '.(($input_val_arr[0] == $_POST['wpcc_structure'][$row->wpcc_field])?'selected':'').'>'.$input_val_arr[1].'</option>';
						}
					}
					$return .= '
				</select>
			'.$wpcc_clear.'</div>
			';
				}

				if ($row->wpcc_value == "checkbox")
				{
					$return .= '
			<div class="wpcc_box wpcc_box_'.$row->wpcc_field.' wpcc_jq_if_'.$row->wpcc_field.'" style="display: '.$wpcc_if_display.';">
				<div class="wpcc_description '.(($wpcc_cache_field['title'] == '')?'wpcc_description_empty':'').'">'.$wpcc_cache_field['title'].'</div>';
				
					if($wpcc_cache_field['list'] != '')
					{
						$return .= '<div class="wpcc_checkbox wpcc_checkbox_'.$row->wpcc_field.'">';
						$checkbox_i = '1';
						$checkbox_arr = preg_split('/\\r\\n?|\\n/', $wpcc_cache_field['list']);
						foreach ($checkbox_arr as $checkbox_row)
						{
							$input_val_arr = explode(':',$checkbox_row);
							$return .= '
					<label><input type="checkbox" name="wpcc_structure['.$row->wpcc_field.']['.$checkbox_i.']" value="'.$input_val_arr[0].'" '.((($input_val_arr[0] == $_POST['wpcc_structure'][$row->wpcc_field][$checkbox_i]))?'checked':'').' class="wpcc_jq_'.$row->wpcc_field.'" data-type="'.$row->wpcc_value.'"> '.$input_val_arr[1].'</label>';
							$checkbox_i++;
						}
						$return .= '</div>';
					}
				$return .= '
			'.$wpcc_clear.'</div>
					';
				}

				if ($row->wpcc_value == "radio")
				{
					$radio_i = '1';
					$return .= '
			<div class="wpcc_box wpcc_box_'.$row->wpcc_field.' wpcc_jq_if_'.$row->wpcc_field.'" style="display: '.$wpcc_if_display.';">
				<div class="wpcc_description '.(($wpcc_cache_field['title'] == '')?'wpcc_description_empty':'').'">'.$wpcc_cache_field['title'].'</div>';
					
					if($wpcc_cache_field['list'] != '')
					{
						$return .= '<div class="wpcc_radio wpcc_radio_'.$row->wpcc_field.'">';
						$select_arr = preg_split('/\\r\\n?|\\n/', $wpcc_cache_field['list']);
						foreach ($select_arr as $select_row)
						{
							$input_val_arr = explode(':',$select_row);
							$return .= '
					<label><input type="radio" name="wpcc_structure['.$row->wpcc_field.']" value="'.$input_val_arr[0].'" '.((($input_val_arr[0] == $_POST['wpcc_structure'][$row->wpcc_field]) OR ($radio_i == '1' AND $_POST['wpcc_structure'][$row->wpcc_field] == ''))?'checked':'').' class="wpcc_jq_'.$row->wpcc_field.'" data-type="'.$row->wpcc_value.'"> '.$input_val_arr[1].'</label>';
							$radio_i++;
						}
						$return .= '</div>';
					}
					$return .= '
			'.$wpcc_clear.'</div>
				';
				}
				
				if ($row->wpcc_value == "inputtext")
				{
					$return .= '
			<div class="wpcc_box wpcc_box_'.$row->wpcc_field.' wpcc_jq_if_'.$row->wpcc_field.'" style="display: '.$wpcc_if_display.';">
				<div class="wpcc_description '.(($wpcc_cache_field['title'] == '')?'wpcc_description_empty':'').'">'.$wpcc_cache_field['title'].'</div>
				<input type="text" name="wpcc_structure['.$row->wpcc_field.']" value="'.(($_POST['wpcc_structure'][$row->wpcc_field] != '')?wpcc_esc_attr($_POST['wpcc_structure'][$row->wpcc_field]):'').'" class="wpcc_inputtext wpcc_inputtext_'.$row->wpcc_field.' wpcc_jq_'.$row->wpcc_field.' '. (($wpcc_cache_field['validation'] != '')?'wpcc_jq_validation_'.$wpcc_cache_field['validation']:'').'" data-type="'.$row->wpcc_value.'">
			'.$wpcc_clear.'</div>
			';
				}
				
				if ($row->wpcc_value == "hidden")
				{
					$return .= '
			<input type="hidden" name="wpcc_structure['.$row->wpcc_field.']" value="'.$wpcc_cache_field['price'].'" class="wpcc_jq_'.$row->wpcc_field.'">'
			;	
				}
				
				if ($row->wpcc_value == "session")
				{
					$wpcc_session = $_SESSION['wpcc_'.$wpcc_cache_field['sess_calc_id']][$wpcc_cache_field['sess_calc_results']];
					$return .= '
			<input type="hidden" name="wpcc_structure['.$row->wpcc_field.']" value="'.(($wpcc_session == '')?$wpcc_cache_field['default']:$wpcc_session).'" class="wpcc_jq_'.$row->wpcc_field.'">
			';	

				}
				
				if ($row->wpcc_value == "jquery")
				{
					$return .= '
			<input type="hidden" name="wpcc_structure['.$row->wpcc_field.']" class="wpcc_jq_copy wpcc_jq_'.$row->wpcc_field.'" value="" data-get_id="'.$wpcc_cache_field['jq_id'].'">
			';	
				}
				
				if ($row->wpcc_value == "armtc")
				{
					$return .= '
			<input type="hidden" name="wpcc_structure['.$row->wpcc_field.']" value="'.$wpcc_cache_field['armtc_fn'].'">
			';	
				}
				
				if ($row->wpcc_value == "slider")
				{
					$slider_val = (($_POST['wpcc_structure'][$row->wpcc_field] != '')?wpcc_price($_POST['wpcc_structure'][$row->wpcc_field]):wpcc_price($wpcc_cache_field['default']));
					$return .= '
			<div class="wpcc_box wpcc_box_'.$row->wpcc_field.' wpcc_jq_slider_'.$wpcc_cache_field['slider_position'].' wpcc_jq_slider wpcc_jq_if_'.$row->wpcc_field.'" style="display: '.$wpcc_if_display.';" data-value="'.$slider_val.'" data-min="'.$wpcc_cache_field['slider_min'].'" data-max="'.$wpcc_cache_field['slider_max'].'" data-position="'.$wpcc_cache_field['slider_position'].'" data-step="'.$wpcc_cache_field['slider_step'].'">
				<div class="wpcc_description wpcc_description_'.$row->wpcc_field.'">'.$wpcc_cache_field['title'].'</div>
				<div class="wpcc_jq_slider_box wpcc_jq_slider_box_'.$row->wpcc_field.'"></div>
				<div class="wpcc_jq_slider_text wpcc_jq_slider_text_'.$row->wpcc_field.'">'.$slider_val.'</div>
				<input type="hidden" name="wpcc_structure['.$row->wpcc_field.']" value="'.$slider_val.'" class="wpcc_jq_slider_hidden wpcc_jq_'.$row->wpcc_field.'" data-type="'.$row->wpcc_value.'">
			'.$wpcc_clear.'</div>
			';	
				}
				
				if ($row->wpcc_value == "result_fields")
				{
					$return .= '
			<input type="hidden" name="wpcc_structure['.$row->wpcc_field.']" class="wpcc_jq_'.$row->wpcc_field.'" value="'. (($_POST['wpcc_structure'][$row->wpcc_field] != '')?wpcc_price($_POST['wpcc_structure'][$row->wpcc_field]):wpcc_price($wpcc_cache_field['default'])) .'">
			';
				}
				
				if ($row->wpcc_value != "textblock" AND $row->wpcc_value != "if")
				{ 
					$wpcc_structure_id []= $row->wpcc_field;
				}
			}
		}
		
		$return .= '
		<input type="hidden" name="wpcc_structure_id" value="'.wpcc_esc_attr(implode(',',$wpcc_structure_id)).'">
		<input type="hidden" name="wpcc_id" class="wpcc_id" value="'.$wpcc_id.'">
		<input type="hidden" name="wpcc_form_url" class="wpcc_url" value="'.WPCC_PLUGIN_URL.'">
		<input type="submit" value="'.$wpcc_submit.'" name="wpcc_calculate" class="wpcc_submit wpcc_submit_'.$wpcc_id.'">
		'. ((is_admin())?'<input type="hidden" name="wpcc_moderator" value="true">':'') .'
		<div class="wpcc_loading"><div></div></div>
	</form>
		';
	}
	$return .= '
	<div class="wpcc_result_block wpcc_result_block_'.$wpcc_id.'">
	';
	
	if (isset($_POST['wpcc_calculate']))
	{
		$return .= wpcc_result($_POST, $moderator);		
	}
	
	if (isset($_POST['wpcc_calculate']) OR isset($_POST['wpcc_mail']))
	{
		$return .= wpcc_mail_form($wpcc_id);
	}
	
	
	$return .='
	</div>
</div>
	';
	return $return;
}
add_shortcode('wpcc', 'wpcc_shortcode');

function wpcc_mail_form($wpcc_id) {
	$wpcc_id 				= intval($wpcc_id);
	$wpcc_mail_check 		= get_option('wpcc_mail_check_'.$wpcc_id);
	$wpcc_mail_text 		= get_option('wpcc_mail_text_'.$wpcc_id);
	
	if($wpcc_mail_check == '1')
	{
			
		if(isset($_POST['wpcc_mail']))
		{
			return wpcc_mail_send($_POST);
		}
		else
		{
			return '
	<form method="POST" action="#wpcc_mail_result" class="wpcc_mail wpcc_mail_'.$wpcc_id.'">
		'.(($wpcc_mail_text != '')?'<div class="wpcc_text">'.nl2br($wpcc_mail_text).'</div>':'').'
		<input type="text" name="wpcc_user_name" value="" placeholder="'. __('Your name', 'wpcc') .'" class="input" required><br>
		<input type="email" name="wpcc_user_email" value="" placeholder="'. __('Your E-Mail', 'wpcc') .'" class="input" required><br>
		<input type="text" name="wpcc_user_phone" value="" placeholder="'. __('Your Phone', 'wpcc') .'" class="input"><br>
		<textarea name="wpcc_user_comment" placeholder="'. __('Your comment', 'wpcc') .'" value="" class="textarea"></textarea><br>
		<input type="hidden" name="wpcc_id" class="wpcc_id" value="'.$wpcc_id.'">
		<input type="submit" name="wpcc_mail" class="wpcc_submit" value="'. __('Send', 'wpcc') .'">
		<div class="wpcc_loading"><div></div></div>
	</form>
			';
		}
	}
}

function wpcc_mail_send($POST, $option=array()) {
	global $wpdb, $wpcc_DB;
	
	$wpcc_id 				= intval($POST['wpcc_id']);
	$wpcc_text_to 			= get_option('wpcc_text_to_'.$wpcc_id);
	$wpcc_text_af 			= get_option('wpcc_text_af_'.$wpcc_id);
	$wpcc_mail_check 		= get_option('wpcc_mail_check_'.$wpcc_id);
	$wpcc_mail_subject 		= get_option('wpcc_mail_subject_'.$wpcc_id);
	$wpcc_mail_emailto 		= get_option('wpcc_mail_emailto_'.$wpcc_id);
	$wpcc_mail_text_adm		= get_option('wpcc_mail_text_adm_'.$wpcc_id);
	$wpcc_mail_text_success = get_option('wpcc_mail_text_success_'.$wpcc_id);
	
	$wpcc_user_name 		= wpcc_esc_attr($POST['wpcc_user_name']);
	$wpcc_user_email 		= wpcc_esc_attr($POST['wpcc_user_email']);
	$wpcc_user_phone 		= wpcc_esc_attr($POST['wpcc_user_phone']);
	$wpcc_user_comment 		= nl2br(wpcc_esc_attr($POST['wpcc_user_comment']));

	if($wpcc_mail_check == '1')
	{
		$wpcc_mail_body = '
		<p>'.nl2br($wpcc_mail_text_adm).'</p>
			<table border="0" width="100%" cellpadding="2" style="border-collapse: collapse">
			<tr>
				<td colspan="2" align="left" valign="top" bgcolor="#fff" style="border-bottom: 5px solid #FFFFFF"><b>'. __('Information about the sender', 'wpcc') .'</b></td>
			</tr>
			<tr>
				<td width="250" align="left" valign="top" bgcolor="#FFFFFF" style="border-bottom: 5px solid #FFFFFF">'. __('Name', 'wpcc') .'</td>
				<td style="border-bottom: 5px solid #FFFFFF">'.(($wpcc_user_name == '')?'---':$wpcc_user_name).'</td>
			</tr>
			<tr>
				<td width="250" align="left" valign="top" bgcolor="#FFFFFF" style="border-bottom: 5px solid #FFFFFF">E-Mail</td>
				<td style="border-bottom: 5px solid #FFFFFF">'.(($wpcc_user_email == '')?'---':$wpcc_user_email).'</td>
			</tr>
			<tr>
				<td width="250" align="left" valign="top" bgcolor="#FFFFFF" style="border-bottom: 5px solid #FFFFFF">'. __('Phone', 'wpcc') .'</td>
				<td style="border-bottom: 5px solid #FFFFFF">'.(($wpcc_user_phone == '')?'---':$wpcc_user_phone).'</td>
			</tr>
			<tr>
				<td width="250" align="left" valign="top" bgcolor="#FFFFFF" style="border-bottom: 5px solid #FFFFFF">'. __('Comment', 'wpcc') .'</td>
				<td style="border-bottom: 5px solid #FFFFFF">'.(($wpcc_user_comment == '')?'---':$wpcc_user_comment).'</td>
			</tr>
			<tr>
				<td colspan="2" align="left" valign="top" bgcolor="#fff" style="border-bottom: 5px solid #FFFFFF"><b>'. __('The calculation', 'wpcc') .'</b></td>
			</tr>
		';
		
		$wpcc_session = $_SESSION['wpcc_'.$wpcc_id];
		
		$wpcc_mail_f_ex = array(
			'textblock',
			'if',
			'hidden'
		);
		
		$res = $wpdb->get_results("SELECT * FROM $wpcc_DB WHERE wpcc_id = '$wpcc_id' AND wpcc_type != 'cat' ORDER BY wpcc_order");
		foreach ($res as $row)
		{
			if($row->wpcc_type == 'field_type' AND !in_array($row->wpcc_value, $wpcc_mail_f_ex))
			{
				$wpcc_cache_field 	= wpcc_cache_field($res, $row->wpcc_field);
				$mail_body_title 	= (($wpcc_cache_field['title'] == '')?$row->wpcc_value:$wpcc_cache_field['title']);
				
				if($wpcc_session['names'][$row->wpcc_field] != '')
				{
				$wpcc_mail_body .= '
			<tr>
				<td width="250" align="left" valign="top" bgcolor="#FFFFFF" style="border-bottom: 5px solid #FFFFFF">'.$mail_body_title.'</td>
				<td style="border-bottom: 5px solid #FFFFFF">'.$wpcc_session['names'][$row->wpcc_field].'</td>
			</tr>
				';
				}

			}
		}
		$wpcc_mail_body .= '
		</table>
		<p><b>'.$wpcc_text_to.'</b> '.$wpcc_session['sum'].' '.$wpcc_text_af.' </p>
		<hr>
		<small>
			<p>'. __('Number calculator', 'wpcc') .': '.$wpcc_id.'</p>
			<p><a href="http://www.zetrider.ru" target="_blank" title="'. __('Posted by plugin', 'wpcc') .'">Wordpress Creator Calculator</a></p>
		</small>
		';
		if(isset($POST['wpcc_mail']) OR in_array('ajax', $option))
		{
			$wpcc_mail_headers[] = 'From: '.(($wpcc_user_name != '')?$wpcc_user_name:'NoName').' <'.(($wpcc_user_email != '')?$wpcc_user_email:get_option('admin_email')).'>';
			$wpcc_mail_headers[] = 'Content-type: text/html; charset=utf-8';
			wp_mail($wpcc_mail_emailto, $wpcc_mail_subject.' '.$wpcc_user_name, $wpcc_mail_body, $wpcc_mail_headers);
			return '
	<div class="wpcc_mail wpcc_mail_success" id="wpcc_mail_result">
		<div class="wpcc_text">
			'.nl2br($wpcc_mail_text_success).'
		</div>
	</div>
			';
		}	
	}
}

/* WPCC Parser Array Value */
function wpcc_parsing_post($POST) {
	global $wpdb, $wpcc_DB;
	if($POST['wpcc_structure_id'] != '' AND $POST['wpcc_id'] > '0')
	{
		$wpcc_id = intval($POST['wpcc_id']);
		
		unset($_SESSION['wpcc_'.$wpcc_id]);
		
		/* For all data */
		$wpcc_structure		= $POST['wpcc_structure'];
		$wpcc_structure_id	= preg_replace ('/[^0-9,]/', '', $POST['wpcc_structure_id']);
		
		/**/
		if(count($wpcc_structure_id) > '0')
		{
			$wpcc_structure_arr	= explode(',', $POST['wpcc_structure_id']);
			foreach($wpcc_structure_arr as $wpcc_structure_k)
			{
				$wpcc_structure_list [] = $wpcc_structure_k;
			}
			
			/* IF FIELD */
			$wpcc_if_parse = wpcc_if_parse($wpcc_id);
			
			if(count($wpcc_if_parse['if_hide']) > '0')
			{
				foreach($wpcc_if_parse['if_hide'] AS $field_hide_unset_r)
				{
					if(($ukey = array_search($field_hide_unset_r,$wpcc_structure_list)) !== FALSE){
						 unset($wpcc_structure_list[$ukey]);
					}
				}
			}
			/* IF FIELD END */
			
			$wpcc_structure_q = implode("','", $wpcc_structure_list);
			
			$wpcc_query = $wpdb->get_results("
				SELECT * FROM $wpcc_DB 
				WHERE
					wpcc_id = '$wpcc_id'
				AND
					wpcc_field IN ('$wpcc_structure_q')
			");
			
			foreach ($wpcc_query AS $wpcc_query_row) {
			
				$wpcc_cache_field = wpcc_cache_field($wpcc_query, $wpcc_query_row->wpcc_field);
				
				if($wpcc_query_row->wpcc_type == 'field_type')
				{
					$value_structure = $wpcc_structure[$wpcc_query_row->wpcc_field];
					if(is_array($value_structure))
					{
						if($wpcc_cache_field['action'] == '')
						{
							$value_field = implode(' ', $value_structure);
						}
						else
						{
							$value_eval_str = implode($wpcc_cache_field['action'], $value_structure);
							eval ('$value_field = '.$value_eval_str.';');
						}
						
					}
					else
					{
						$value_field = wpcc_esc_attr($value_structure);
					}
						
					if($wpcc_cache_field['exclude'] == '2') /* For Exclude Field */
					{
						$_SESSION['wpcc_'.$wpcc_id][$wpcc_query_row->wpcc_field] = $value_field;
						
					}
					elseif($wpcc_query_row->wpcc_value == 'result_fields')
					{
						if($wpcc_cache_field['rf_fields'] == '')
						{
							$save_session = $wpcc_cache_field['default'];
						}
						else
						{
							$rf_fields_ex = explode(',', $wpcc_cache_field['rf_fields']);
							foreach($rf_fields_ex AS $rf_fields_row)
							{
								$rf_fields_arr[] = $wpcc_structure[$rf_fields_row];
							}
							$rf_fields_im = implode($wpcc_cache_field['action'], $rf_fields_arr);
							eval ('$save_session = '.$rf_fields_im.';');
						}
						$return[$wpcc_query_row->wpcc_order] .= $wpcc_cache_field['signto'].$save_session.$wpcc_cache_field['signaf'];
						$_SESSION['wpcc_'.$wpcc_id][$wpcc_query_row->wpcc_field] = $save_session;
					}
					else
					{					
						if($value_field == '')
						{
							if($wpcc_query_row->wpcc_value == 'inputtext')
							{
								$return[$wpcc_query_row->wpcc_order] .= $wpcc_cache_field['signto'].'('.$wpcc_cache_field['default'].$wpcc_cache_field['action'].$wpcc_cache_field['price'].')'.$wpcc_cache_field['signaf'];
								eval ('$save_session = '.$wpcc_cache_field['default'].$wpcc_cache_field['action'].$wpcc_cache_field['price'].';');
								$_SESSION['wpcc_'.$wpcc_id][$wpcc_query_row->wpcc_field.'_sum'] = $save_session;
							}
							else
							{
								$return[$wpcc_query_row->wpcc_order] .= $wpcc_cache_field['signto'].$wpcc_cache_field['default'].$wpcc_cache_field['signaf'];
							}
							$_SESSION['wpcc_'.$wpcc_id][$wpcc_query_row->wpcc_field] = $wpcc_cache_field['default'];
						}
						else
						{
							$value_field = str_replace(',','.', $value_field);
							
							if($wpcc_cache_field['validation'] == 'only_numbers')
							{
								$value_field = wpcc_price($value_field);
							}
							
							if($wpcc_query_row->wpcc_value == 'inputtext')
							{
								$return[$wpcc_query_row->wpcc_order] .= $wpcc_cache_field['signto'].'('.$value_field.$wpcc_cache_field['action'].$wpcc_cache_field['price'].')'.$wpcc_cache_field['signaf'];
								eval ('$save_session = '.$value_field.$wpcc_cache_field['action'].$wpcc_cache_field['price'].';');
								$_SESSION['wpcc_'.$wpcc_id][$wpcc_query_row->wpcc_field.'_sum'] = $save_session;
							}
							else
							{
								$return[$wpcc_query_row->wpcc_order] .= $wpcc_cache_field['signto'].$value_field.$wpcc_cache_field['signaf'];
							}
							$_SESSION['wpcc_'.$wpcc_id][$wpcc_query_row->wpcc_field] = $value_field;
						}
					}
					
					/* Save Selected Field Name */
					$select_sort_array = '';
					$session_names_val = '';
					if($wpcc_query_row->wpcc_value == 'select' OR $wpcc_query_row->wpcc_value == 'radio' OR $wpcc_query_row->wpcc_value == 'checkbox')
					{
						if($wpcc_cache_field['list'] != '')
						{
							/* Create Sort Array Key = Value Field, Value = Name Field */
							$select_arr = preg_split('/\\r\\n?|\\n/', $wpcc_cache_field['list']);

							foreach($select_arr AS $select_row)
							{
								$select_arr_exp = explode(':', $select_row);
								$select_sort_array[$select_arr_exp[0]] = $select_arr_exp[1];
							}
							
							/* Add Selected Name */
							if(is_array($value_structure))
							{
								foreach($value_structure AS $value_structure_r)
								{
									$session_names_val[] = $select_sort_array[$value_structure_r];
								}
							}
							else
							{
								
								$session_names_val[] = $select_sort_array[$value_structure];
							}
						}
					}
					else
					{
						$session_names_val[] = $value_structure;
					}
					
					if(empty($session_names_val))
					{
						$session_names_val = array();
					}
					$session_name_save[$wpcc_query_row->wpcc_field] = implode(', ',$session_names_val);
				}
			}
			
			$_SESSION['wpcc_'.$wpcc_id]['names'] = $session_name_save;
			
		}
		
		/* Sort an array by key */
		if(!empty($return))
		{
			ksort($return);
		}
		return $return;
	}
	else
	{
		return false;
	}
}
/* Success :) */